## ros-humble-velodyne-pointcloud 2.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(velodyne_pointcloud)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(angles REQUIRED)
find_package(diagnostic_updater REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(message_filters REQUIRED)
find_package(PCL REQUIRED COMPONENTS common)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(velodyne_msgs REQUIRED)

# Resolve system dependency on yaml-cpp, which apparently does not
# provide a CMake find_package() module.
find_package(PkgConfig REQUIRED)
pkg_check_modules(YAML_CPP REQUIRED yaml-cpp)
find_path(YAML_CPP_INCLUDE_DIR
  NAMES yaml_cpp.h
  PATHS ${YAML_CPP_INCLUDE_DIRS})
find_library(YAML_CPP_LIBRARY
  NAMES YAML_CPP
  PATHS ${YAML_CPP_LIBRARY_DIRS})

link_directories(${YAML_CPP_LIBRARY_DIRS})

if(NOT ${YAML_CPP_VERSION} VERSION_LESS "0.5")
  add_definitions(-DHAVE_NEW_YAMLCPP)
endif()

include_directories(include ${PCL_COMMON_INCLUDE_DIRS})

add_subdirectory(src/lib)

add_library(transform SHARED
  src/conversions/transform.cpp)
ament_target_dependencies(transform
  diagnostic_updater
  message_filters
  rclcpp
  rclcpp_components
  tf2
  tf2_ros
)
target_link_libraries(transform
  velodyne_cloud_types
  velodyne_rawdata
  ${YAML_CPP_LIBRARIES})
install(TARGETS transform
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)
rclcpp_components_register_nodes(transform
  "velodyne_pointcloud::Transform")

add_executable(velodyne_transform_node
  src/conversions/transform_node.cpp)
ament_target_dependencies(velodyne_transform_node
  rclcpp
)
target_link_libraries(velodyne_transform_node
  transform)
install(TARGETS velodyne_transform_node
  DESTINATION lib/${PROJECT_NAME})

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME})
install(DIRECTORY config launch params
  DESTINATION share/${PROJECT_NAME})
# install(PROGRAMS scripts/gen_calibration.py
#         DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

if(BUILD_TESTING)
  # Remove empty.xml from lint
  list(APPEND AMENT_LINT_AUTO_EXCLUDE
    ament_cmake_xmllint
  )

  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  file(GLOB_RECURSE XML_FILES
    "*.xml"
  )

  get_filename_component(
    EMPTY_XML_ABS
    "tests/empty.xml"
    ABSOLUTE
  )

  list(REMOVE_ITEM XML_FILES ${EMPTY_XML_ABS})

  find_package(ament_cmake_xmllint REQUIRED)

  ament_xmllint(${XML_FILES})

  add_subdirectory(tests)
endif()

ament_package()

=== tests/CMakeLists.txt ===
# these dependencies are only needed for unit testing
find_package(ament_cmake_gtest REQUIRED)

ament_add_gtest(test_row_step test_row_step.cpp)
ament_target_dependencies(test_row_step
  geometry_msgs
  rclcpp
  sensor_msgs
  tf2_ros
  velodyne_msgs
)

ament_add_gtest(test_calibration
  test_calibration.cpp
)

target_link_libraries(test_calibration
  velodyne_rawdata
)

ament_target_dependencies(test_calibration
  rclcpp
)

target_link_libraries(test_calibration
  ${YAML_CPP_LIBRARIES}
)

# # Download packet capture (PCAP) files containing test data.
# # Store them in devel-space, so rostest can easily find them.
# catkin_download_test_data(
#   ${PROJECT_NAME}_tests_class.pcap
#   http://download.ros.org/data/velodyne/class.pcap
#   DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/tests
#   MD5 65808d25772101358a3719b451b3d015)
# catkin_download_test_data(
#   ${PROJECT_NAME}_tests_32e.pcap
#   http://download.ros.org/data/velodyne/32e.pcap
#   DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/tests
#   MD5 e41d02aac34f0967c03a5597e1d554a9)
# catkin_download_test_data(
#   ${PROJECT_NAME}_tests_64e_s2.1-300-sztaki.pcap
#   http://download.ros.org/data/velodyne/64e_s2.1-300-sztaki.pcap
#   DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/tests
#   MD5 176c900ffb698f9b948a13e281ffc1a2)
# catkin_download_test_data(
#   ${PROJECT_NAME}_tests_vlp16.pcap
#   http://download.ros.org/data/velodyne/vlp16.pcap
#   DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/tests
#   MD5 f45c2bb1d7ee358274e423ea3b66fd73)

# run rostests
# add_rostest(transform_node_hz.test)
# add_rostest(transform_nodelet_hz.test)
# add_rostest(transform_node_32e_hz.test)
# add_rostest(transform_nodelet_32e_hz.test)
# add_rostest(transform_node_64e_s2.1_hz.test)
# add_rostest(transform_nodelet_64e_s2.1_hz.test)
# add_rostest(transform_node_vlp16_hz.test)
# add_rostest(transform_nodelet_vlp16_hz.test)
# add_rostest(two_nodelet_managers.test)

# # parse check all the launch/*.launch files
# roslaunch_add_file_check(../launch)

=== src/lib/CMakeLists.txt ===
add_library(velodyne_rawdata SHARED
  rawdata.cpp
  calibration.cpp)
ament_target_dependencies(velodyne_rawdata
  angles
  geometry_msgs
  rclcpp
  sensor_msgs
  tf2
  tf2_ros
  velodyne_msgs
)
target_link_libraries(velodyne_rawdata
  ${PCL_LIBRARIES}
)

target_link_libraries(velodyne_rawdata
        ${YAML_CPP_LIBRARIES})

add_library(velodyne_cloud_types SHARED
  pointcloudXYZIRT.cpp
  organized_cloudXYZIRT.cpp
)
ament_target_dependencies(velodyne_cloud_types
  rclcpp
  sensor_msgs
  tf2_ros
  velodyne_msgs
)
target_link_libraries(velodyne_cloud_types
  ${PCL_LIBRARIES}
)

install(TARGETS velodyne_cloud_types velodyne_rawdata
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib)

=== debian/changelog ===
ros-humble-velodyne-pointcloud (2.4.0-1jammy) jammy; urgency=high

  * Add invalid points in organized cloud (#360 <https://github.com/ros-drivers/velodyne/issues/360>) (#492 <https://github.com/ros-drivers/velodyne/issues/492>)
    * Set NaN in ordered point cloud in case of no return
    * Adapt to current master
    * consider min/max angle and timing_offsets also in organized mode
    Co-authored-by: Sebastian Scherer <mailto:sebastian.scherer2@de.bosch.com>
    Co-authored-by: Nuernberg Thomas (CR/AEV4) <mailto:thomas.nuernberg@de.bosch.com>
  * Fixed row_step=0 when init_width=0 (dense cloud) (#404 <https://github.com/ros-drivers/velodyne/issues/404>) (#494 <https://github.com/ros-drivers/velodyne/issues/494>)
    The PointCloud2 msg will be then valid: http://docs.ros.org/en/melodic/api/sensor_msgs/html/msg/PointCloud2.html
    Referred issues:
    * https://answers.ros.org/question/377470/rtabmap-icp_odometrycpp453callbackcloud-fatal-error/
    * http://official-rtab-map-forum.67519.x6.nabble.com/Condition-scan3dMsg-data-size-scan3dMsg-row-step-scan3dMsg-height-not-met-td7852.html
    Co-authored-by: matlabbe <mailto:matlabbe@gmail.com>
  * Unify tf frame parameters between transform and cloud nodes (#344 <https://github.com/ros-drivers/velodyne/issues/344>) (#453 <https://github.com/ros-drivers/velodyne/issues/453>)
    * Unify tf frame parameters between transform and cloud nodes
    At this point there is no need any more for cloud node because transform node includes all features of cloud node.
    Co-authored-by: AndreasR30 <mailto:andreas-reich@live.de>
    Co-authored-by: anre <mailto:andreas.reich@unibw.de>
  * fix: modify some tests (#452 <https://github.com/ros-drivers/velodyne/issues/452>)
    * Fixing new linter errors.
    * Changing command for running tests.
    * remove relative file path
    * remove unnecessary main
    * fix: restore hdl64e s2 float intensities test
    Co-authored-by: Joshua Whitley <mailto:jwhitley@autonomoustuff.com>
  * Contributors: Daisuke Nishimatsu

 -- Josh Whitley <whitleysoftwareservices@gmail.com>  Fri, 26 May 2023 16:00:00 -0000

ros-humble-velodyne-pointcloud (2.3.0-1jammy) jammy; urgency=high

  * Passing fixed_frame and target_frame to Convert object. (#330 <https://github.com/ros-drivers/velodyne/issues/330>) (#451 <https://github.com/ros-drivers/velodyne/issues/451>)
    Co-authored-by: Joshua Whitley <mailto:jwhitley@autonomoustuff.com>
  * Updating maintainer email address. (#450 <https://github.com/ros-drivers/velodyne/issues/450>)
    * Updating maintainer email address.
    * chore: update maintainer email address
    Co-authored-by: Joshua Whitley <mailto:jwhitley@autonomoustuff.com>
  * Add per point time field (#440 <https://github.com/ros-drivers/velodyne/issues/440>)
    * Initial commit to timestamp each point using the timing spec in the manuals
    * Added model param to each of the cloud nodelet starters
    * Minor cleanup. added author tag to rawdata
    * Move timing offsets functionality into class private. Also fix linter errors
    * added #include <vector> for linter
    * fix: suppress compiler warning
    * feat: change XYZIR to XYZIRT
    Co-authored-by: Shawn Hanna <mailto:shawn@kaarta.com>
  * Link against yaml-cpp (#443 <https://github.com/ros-drivers/velodyne/issues/443>)
  * Increase the max_range of the 32C launch file (#323 <https://github.com/ros-drivers/velodyne/issues/323>) (#441 <https://github.com/ros-drivers/velodyne/issues/441>)
    Co-authored-by: Shawn Hanna <mailto:50845122+kaarta-SHanna@users.noreply.github.com>
  * fix for #267 <https://github.com/ros-drivers/velodyne/issues/267>, transform each packet (#438 <https://github.com/ros-drivers/velodyne/issues/438>)
    * fix for #267 <https://github.com/ros-drivers/velodyne/issues/267>, transform each packet
    * fix: fix scope of access modifiers
    Co-authored-by: Sebastian <mailto:spuetz@uos.de>
  * Replace deprecated argument names in launch (#430 <https://github.com/ros-drivers/velodyne/issues/430>)
  * 2.1.1
  * Updating for first Galactic release
  * Contributors: Daisuke Nishimatsu, Joshua Whitley, Keane Quigley, Stephan Sundermann

 -- Josh Whitley <whitleysoftwareservices@gmail.com>  Thu, 07 Jul 2022 16:00:00 -0000

ros-humble-velodyne-pointcloud (2.1.1-1jammy) jammy; urgency=high



 -- Josh Whitley <whitleysoftwareservices@gmail.com>  Sun, 22 Aug 2021 16:00:00 -0000

ros-humble-velodyne-pointcloud (2.1.0-1jammy) jammy; urgency=high



 -- Josh Whitley <whitleysoftwareservices@gmail.com>  Thu, 09 Jul 2020 16:00:00 -0000

ros-humble-velodyne-pointcloud (2.0.0-1jammy) jammy; urgency=high

  * More fixing of dependencies. (#333 <https://github.com/ros-drivers/velodyne/issues/333>)
    * More fixing of dependencies.
  * Fixes pointed out by clang-tidy (#310 <https://github.com/ros-drivers/velodyne/issues/310>)
    * Rearrange header includes so clang-tidy is happy.
    * Get rid of unnecessary void arguments on methods.
    * Properly mark methods as override where appropriate.
    * Initialize members and stack variables to zero before use.
    * Mark function implementations in header files 'inline'.
    * Use more efficient 'empty' method instead of empty string.
    * Get rid of unnecessary else statements after a continue/return.
    * Get rid of unnecessary == false use.
    * Make sure to add a virtual destructor to DataContainerBase.
    * Use string != comparison instead of 'compare' method.
    * Rename PointcloudXYZIR parameter name to match implementation.
    * Get rid of usage of typedef.
    * Be more explicit about using floats.
    * Do an explicit lround to do int->float conversion.
    * Fix the intensity calculation.
    * Remove the azimuth from addPoint.
    * Make sure to reset the cloud data to 0 before reusing.
    * Use underscores on pointcloud member variables.
    * Using std::lround means we don't need to add 0.5 to the result.
    * Slightly rearrange and simplify range checks.


=== debian/control ===
Source: ros-humble-velodyne-pointcloud
Section: misc
Priority: optional
Maintainer: Josh Whitley <whitleysoftwareservices@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libpcl-dev, libyaml-cpp-dev, ros-humble-ament-cmake, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-angles, ros-humble-diagnostic-updater, ros-humble-geometry-msgs, ros-humble-message-filters, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-tf2, ros-humble-tf2-ros, ros-humble-velodyne-msgs, ros-humble-ros-workspace
Homepage: http://ros.org/wiki/velodyne_pointcloud
Standards-Version: 3.9.2

Package: ros-humble-velodyne-pointcloud
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcl-dev, libyaml-cpp-dev, ros-humble-angles, ros-humble-diagnostic-updater, ros-humble-geometry-msgs, ros-humble-message-filters, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-tf2, ros-humble-tf2-ros, ros-humble-velodyne-msgs, ros-humble-ros-workspace
Description: Point cloud conversions for Velodyne 3D LIDARs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-velodyne-pointcloud//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
